%Simplex Program Only For Computing Epoch Times !!!
clear;    %clear all variables in memory

%----------------INPUT PARAMETERS: ----------------------
fid = fopen('Parameters.txt','r');  %input file  *.in  with the initial LITE parameters, only for reading
row=0;
i=0;
while row ~= -1
    i=i+1;
    row=fgets(fid);
    if i == 1
        BBB = strread(row, '%c', 'delimiter', ',');
%         Star = cellstr([BBB(1) BBB(2) BBB(3) BBB(4) BBB(5) BBB(6) BBB(7) BBB(8) BBB(9) BBB(10)]); 
        Star = cellstr(BBB);
        Star = Star';
    else
       if row ~= -1
         A=sscanf(row,'%f');
         Y(i-1)=A(1);
       end
    end
end
status = fclose('all');      %close the file
clear A row i fid status BBB;    %it is better to clear all unnecessary variables from the memory
Y=Y';
%------------------------------------------------------------

%---------------INPUT DATA POINTS (=minima times): ---------------------
fid2 = fopen('Minima.txt','r');  %input file  *.min  with the data (times of minima - JDi), open only for reading
row=0;
i=0;
while row ~= -1
    i=i+1;
    row=fgets(fid2);
    if i ~= 1
       if row ~= -1
         A=sscanf(row,'%f');
         Minima(i-1)=A(1);
         Weight(i-1)=A(2);
     end
    end
end
status = fclose('all');
clear A row fid2 status;
%----------------------------------------------------------------

N=i-2;      %number of data points (minima times)

Minima=Minima';     %minima times
Weight=Weight';      %weights of individual minima times
JDi=Minima+2400000;   %Juliane date of individual minima times

JD00=Y(1);    %here are the 8 parameters of the LITE from the Y matrix
P=Y(2);
p3=Y(3);
T0=Y(4);
A=Y(5);
omega=Y(6);
excen=Y(7);
qmt=-1*Y(8);
p4=Y(9);
T04=Y(10);
A4=Y(11);
omega4=Y(12);
excen4=Y(13);

clear Y i Minima;

EpoLin=Epoch(JDi,JD00,P);    %Epoch of individual minima times

% for i=1:length(Epo)
%     if Epo(i) > 40000
%         Epo(i)=Epo(i)+0.5;
%     elseif Epo(i)>56000
%         Epo(i)=Epo(i)+1;
%     end
% end

for i=1:length(JDi)
    if qmt ~= 0
        clear C;
        C(1)=qmt*10^(-10);
        C(2)=(-1)*P;
        C(3)=JDi(i)-JD00;
        EpKoren=roots(C);
        Rozdil1 = abs(EpoLin(i)-EpKoren(1));
        Rozdil2 = abs(EpoLin(i)-EpKoren(2));
        if min(Rozdil1,Rozdil2) == Rozdil1 
            Epo0(i) = EpKoren(1);
        else
            Epo0(i) = EpKoren(2);
        end
        clear Rozdil1 Rozdil2;
    else
        Epo0(i)=Epoch(JDi(i),JD00,P);    %Epoch of individual minima times
    end
end

Epo0=Epo0';
clear EpoLin;
O=JDi-JD00-P*Epo0;        %O-C difference

for i = 1:N
   if ((Epo0(i)-round(Epo0(i))) >= -0.25) & ((Epo0(i)-round(Epo0(i))) <= 0.25)
      vysledek(i)=round(Epo0(i));             %primary minima times
  else
      if ((Epo0(i)-round(Epo0(i))) > 0.25) & ((Epo0(i)-round(Epo0(i))) < 0.75)
         vysledek(i)=round(Epo0(i))+0.5;   %secondary minima times
     else
         if ((Epo0(i)-round(Epo0(i))) > -0.75) & ((Epo0(i)-round(Epo0(i))) < -0.25)
            vysledek(i)=round(Epo0(i))-0.5;       %secondary minima times
        else
            disp('Something is wrong!')
         end
      end
   end
end
% vysledek=sort(vysledek);

clear O E11 E21 Epo0;
Epo0=vysledek';
O=JDi-JD00-P*Epo0;        %O-C difference

j=1;
k=1;
for i = 1:N
   switch round(10*abs(Epo0(i)-round(Epo0(i))))
   case 0
      E11(j)=Epo0(i);    %primary minima times
      Occ1(j)=O(i);
      B1(j)=Weight(i);
      j=j+1;
   case 5            %secondary minima times
      E21(k)=Epo0(i);
      Occ2(k)=O(i);
      B2(k)=Weight(i);
      k=k+1;
   end
end

m=1;
n=1;
o=1;
o1=1;
remove=0;       %some minima times were eliminated
for i = 1:j-1     %primary minima times
   switch B1(i)
   case 0          %weight = 0  =>  ignore this minimum!
      remove=remove+1;     %removed minima times (=weight 0)
   case 1        %visual primary minima times
      E1v(n)=E11(i);
      O1v(n)=Occ1(i);
      n=n+1;
   case 3       %photographic primary minima times, worse quality
      E1pp(o1)=E11(i);
      O1pp(o1)=Occ1(i);
      o1=o1+1;
   case 5        %photographic primary minima times
      E1p(o)=E11(i);
      O1p(o)=Occ1(i);
      o=o+1;
   case 10       %ccd primary minima times
      E1c(m)=E11(i);
      O1c(m)=Occ1(i);
      m=m+1;
   end
end

p=1;
q=1;
r=1;
o2=1;
for i = 1:k-1     %secondary minima times
   switch B2(i)
   case 0
      remove=remove+1;   %removed secondary minima times
   case 1         %visual secondary minima times
      E2v(p)=E21(i);
      O2v(p)=Occ2(i);
      p=p+1;
   case 3       %photographic secondary minima times, worse quality
      E2pp(o2)=E21(i);
      O2pp(o2)=Occ2(i);
      o2=o2+1;
   case 5         %photographic secondary minima times
      E2p(q)=E21(i);
      O2p(q)=Occ2(i);
      q=q+1;
   case 10        %ccd secondary minima times
      E2c(r)=E21(i);
      O2c(r)=Occ2(i);
      r=r+1;
   end
end

Ep=Epo0(1):10:Epo0(length(Epo0));        %plot a curve from minimumE to maximumE
JDi0=Ep*P+JD00;
Oc=OminusC(JDi0,T0,A,p3,omega,excen)+OminusC(JDi0,T04,A4,p4,omega4,excen4)-10^(-10)*qmt*Ep.*Ep;
Oc3=OminusC(JDi0,T0,A,p3,omega,excen)-10^(-10)*qmt*Ep.*Ep;
OcMT=-10^(-10)*qmt*Ep.*Ep;

%--------------- HERE PLOT THE FIGURE: --------------------
figure(1);
if n > 1 plot(E1v,O1v,'k.','MarkerSize',6); end    %plot primary visual minima times
hold on
if o1 > 1 plot(E1pp,O1pp,'k.','MarkerSize',8); end  %primary photographic minima times, worse quality
if o > 1 plot(E1p,O1p,'k.','MarkerSize',12); end   %primary photographic minima times
if m > 1 plot(E1c,O1c,'k.','MarkerSize',17); end   %primary ccd minima times
if p > 1 plot(E2v,O2v,'ko','MarkerSize',2); end    %secondary visual minima times
if o2 > 1 plot(E2pp,O2pp,'ko','MarkerSize',2); end  %secondary photographic minima times, worse quality
if q > 1 plot(E2p,O2p,'ko','MarkerSize',3); end    %secondary photographic minima times
if r > 1 plot(E2c,O2c,'ko','MarkerSize',4); end    %secondary ccd minima times
plot(Ep,Oc,'r-');
plot(Ep,Oc3,'b-');
plot(Ep,OcMT,'g-');
set(gca,'box','on');
xlabel('Epoch');   %labeling the axis
ylabel('O-C (Days)');
title('O-C diagram');   %labeling the figure
hold off
%--------------------------------------------------------------------------

Output=[JDi'; Weight'; vysledek];

BB=char(Star);
%-------------- O U T P U T --------------->>>
fid = fopen('Epoch.txt','w');
fprintf(fid,'%s',BB,': Epoch times');
fprintf(fid,'%s\n','');
fprintf(fid,'%12.6f   %2.0f   %8.2f\n',Output);
status=fclose('all');
